From f36ab46cab578ba78f0e03f22411de495ff30a4d Mon Sep 17 00:00:00 2001
From: Matthew Harmsen <mharmsen@redhat.com>
Date: Fri, 9 Mar 2012 19:54:20 -0800
Subject: [PATCH] Get DOGTAG_9_BRANCH GIT repository in-sync with SVN namesake

Migrated the following bugs:
- Bugzilla Bug #747381 - After the migration (7.1->8.1) CA agent page
  displays admin cert request with authtime attribute twice
- Bugzilla Bug #747019 - Migrated policy requests from 7.1->8.1 displays
  issuedcerts and cert_Info params as base 64 blobs.
- Bugzilla Bug #757848 - DRM re-key tool: introduces a blank line in the
  middle of an ldif entry.
---
 pki/CMakeLists.txt                                 |   10 ++--
 .../cms/servlet/request/CertReqParser.java         |   16 +++++
 .../src/com/netscape/cmstools/DRMTool.java         |    2 +-
 .../shared/webapps/ca/agent/ca/processReq.template |   10 +++-
 pki/scripts/compose_dogtag_pki_theme_packages      |    2 +-
 pki/scripts/compose_pki_core_packages              |    2 +-
 pki/scripts/compose_pki_kra_packages               |    2 +-
 pki/scripts/compose_pki_ocsp_packages              |    2 +-
 pki/scripts/compose_pki_tks_packages               |    2 +-
 pki/specs/dogtag-pki-theme.spec                    |   36 +++++++++++-
 pki/specs/dogtag-pki.spec                          |   42 ++++++++-----
 pki/specs/pki-core.spec                            |   62 ++++++++++++++++++--
 pki/specs/pki-kra.spec                             |   18 ++++--
 pki/specs/pki-ocsp.spec                            |   10 +++-
 pki/specs/pki-tks.spec                             |   10 +++-
 15 files changed, 182 insertions(+), 44 deletions(-)

diff --git a/pki/CMakeLists.txt b/pki/CMakeLists.txt
index 88c0a0e..4a8ae0f 100644
--- a/pki/CMakeLists.txt
+++ b/pki/CMakeLists.txt
@@ -17,26 +17,26 @@ if (BUILD_IPA_PKI_THEME)
 elseif (BUILD_DOGTAG_PKI_THEME)
     set(APPLICATION_FLAVOR_DOGTAG_PKI_THEME TRUE)
     # override APPLICATION VERSION
-    set(APPLICATION_VERSION_PATCH "9")
+    set(APPLICATION_VERSION_PATCH "11")
 elseif (BUILD_REDHAT_PKI_THEME)
     set(APPLICATION_FLAVOR_REDHAT_PKI_THEME TRUE)
 elseif (BUILD_PKI_CORE)
     set(APPLICATION_FLAVOR_PKI_CORE TRUE)
     # override APPLICATION VERSION
-    set(APPLICATION_VERSION_PATCH "16")
+    set(APPLICATION_VERSION_PATCH "18")
 elseif (BUILD_PKI_KRA)
     set(APPLICATION_FLAVOR_PKI_KRA TRUE)
     # override APPLICATION VERSION
-    set(APPLICATION_VERSION_PATCH "9")
+    set(APPLICATION_VERSION_PATCH "10")
 elseif (BUILD_PKI_OCSP)
     set(APPLICATION_FLAVOR_PKI_OCSP TRUE)
-    set(APPLICATION_VERSION_PATCH "8")
+    set(APPLICATION_VERSION_PATCH "9")
 elseif (BUILD_PKI_RA)
     set(APPLICATION_FLAVOR_PKI_RA TRUE)
     set(APPLICATION_VERSION_PATCH "4")
 elseif (BUILD_PKI_TKS)
     set(APPLICATION_FLAVOR_PKI_TKS TRUE)
-    set(APPLICATION_VERSION_PATCH "8")
+    set(APPLICATION_VERSION_PATCH "9")
 elseif (BUILD_PKI_TPS)
     set(APPLICATION_FLAVOR_PKI_TPS TRUE)
     # override APPLICATION VERSION
diff --git a/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java b/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java
index 2e0508b..bfa9710 100644
--- a/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java
+++ b/pki/base/common/src/com/netscape/cms/servlet/request/CertReqParser.java
@@ -213,6 +213,22 @@ public class CertReqParser extends ReqParser {
                     String parami = 
                         IRequest.SERVER_ATTRS + LB + String.valueOf(saCounter++) + RB;
 
+                    if (name.equalsIgnoreCase(IRequest.ISSUED_CERTS) && mDetails &&
+                        (req.getRequestStatus().toString().equals(RequestStatus.COMPLETE_STRING) ||
+                            req.getRequestType().equals(IRequest.GETREVOCATIONINFO_REQUEST))) {
+                        X509CertImpl issuedCert[] =
+                            req.getExtDataInCertArray(IRequest.ISSUED_CERTS);
+                        if (issuedCert != null && issuedCert[0] != null) {
+                            val = "<pre>"+CMS.getCertPrettyPrint(issuedCert[0]).toString(l)+"</pre>";
+                        }
+                    } else if (name.equalsIgnoreCase(IRequest.CERT_INFO) && mDetails) {
+                        X509CertInfo[] certInfo =
+                            req.getExtDataInCertInfoArray(IRequest.CERT_INFO);
+                        if (certInfo != null && certInfo[0] != null) {
+                            val = "<pre>"+certInfo[0].toString()+"</pre>";
+                        }
+                    }
+
                     valstr = expandValue(prefix + parami + ".value", val);
                     String rawJS = "new Object;\n\r" +
                         prefix + parami + ".name=\"" +
diff --git a/pki/base/java-tools/src/com/netscape/cmstools/DRMTool.java b/pki/base/java-tools/src/com/netscape/cmstools/DRMTool.java
index 30f742c..47a77e6 100644
--- a/pki/base/java-tools/src/com/netscape/cmstools/DRMTool.java
+++ b/pki/base/java-tools/src/com/netscape/cmstools/DRMTool.java
@@ -2126,7 +2126,7 @@ public class DRMTool
             }
         }
 
-        return revised_data;
+        return revised_data.replaceAll("\\s+$", "");
     }
 
 
diff --git a/pki/dogtag/ca-ui/shared/webapps/ca/agent/ca/processReq.template b/pki/dogtag/ca-ui/shared/webapps/ca/agent/ca/processReq.template
index 5bc143b..2f8fc77 100644
--- a/pki/dogtag/ca-ui/shared/webapps/ca/agent/ca/processReq.template
+++ b/pki/dogtag/ca-ui/shared/webapps/ca/agent/ca/processReq.template
@@ -1013,7 +1013,15 @@ function renderRequestAttrs()
 	if (result.header.AUTH_TOKEN.length > 0) {
 		document.writeln("");
 		for (var k = 0; k < result.header.AUTH_TOKEN.length; k++) {
-			renderNameAndValue("AUTH_TOKEN."+result.header.AUTH_TOKEN[k].name+":", result.header.AUTH_TOKEN[k].value);
+			if (result.header.AUTH_TOKEN[k].name == 'authtime') {
+				renderNameAndValue("AUTH_TOKEN."+result.header.AUTH_TOKEN[k].name+":",
+					new Date(parseInt(result.header.AUTH_TOKEN[k].value)));
+			} else if (result.header.AUTH_TOKEN[k].name == 'authTime') {
+				continue;
+			} else {
+				renderNameAndValue("AUTH_TOKEN."+result.header.AUTH_TOKEN[k].name+":",
+					result.header.AUTH_TOKEN[k].value);
+			}
 		}
 	}
 	if (result.header.SERVER_ATTRS.length > 0) {
diff --git a/pki/scripts/compose_dogtag_pki_theme_packages b/pki/scripts/compose_dogtag_pki_theme_packages
index b89abd8..935ee40 100755
--- a/pki/scripts/compose_dogtag_pki_theme_packages
+++ b/pki/scripts/compose_dogtag_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 DOGTAG_PKI_THEME="dogtag-pki-theme"
-DOGTAG_PKI_THEME_VERSION="9.0.9"
+DOGTAG_PKI_THEME_VERSION="9.0.11"
 
 
 ##
diff --git a/pki/scripts/compose_pki_core_packages b/pki/scripts/compose_pki_core_packages
index a1a2382..43015a7 100755
--- a/pki/scripts/compose_pki_core_packages
+++ b/pki/scripts/compose_pki_core_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CORE="pki-core"
-PKI_CORE_VERSION="9.0.16"
+PKI_CORE_VERSION="9.0.18"
 
 
 ##
diff --git a/pki/scripts/compose_pki_kra_packages b/pki/scripts/compose_pki_kra_packages
index cea2d7b..568f168 100755
--- a/pki/scripts/compose_pki_kra_packages
+++ b/pki/scripts/compose_pki_kra_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_KRA="pki-kra"
-PKI_KRA_VERSION="9.0.9"
+PKI_KRA_VERSION="9.0.10"
 
 
 ##
diff --git a/pki/scripts/compose_pki_ocsp_packages b/pki/scripts/compose_pki_ocsp_packages
index 5a946a2..99362ae 100755
--- a/pki/scripts/compose_pki_ocsp_packages
+++ b/pki/scripts/compose_pki_ocsp_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_OCSP="pki-ocsp"
-PKI_OCSP_VERSION="9.0.8"
+PKI_OCSP_VERSION="9.0.9"
 
 
 ##
diff --git a/pki/scripts/compose_pki_tks_packages b/pki/scripts/compose_pki_tks_packages
index 1816662..76303a9 100755
--- a/pki/scripts/compose_pki_tks_packages
+++ b/pki/scripts/compose_pki_tks_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_TKS="pki-tks"
-PKI_TKS_VERSION="9.0.8"
+PKI_TKS_VERSION="9.0.9"
 
 
 ##
diff --git a/pki/specs/dogtag-pki-theme.spec b/pki/specs/dogtag-pki-theme.spec
index 0ace718..5df653c 100644
--- a/pki/specs/dogtag-pki-theme.spec
+++ b/pki/specs/dogtag-pki-theme.spec
@@ -1,5 +1,5 @@
 Name:             dogtag-pki-theme
-Version:          9.0.9
+Version:          9.0.11
 Release:          1%{?dist}
 Summary:          Certificate System - Dogtag PKI Theme Components
 URL:              http://pki.fedoraproject.org/
@@ -350,6 +350,40 @@ chmod 755 %{buildroot}%{_datadir}/pki/tps-ui/cgi-bin/sow/cfg.pl
 
 
 %changelog
+* Fri Mar  9 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.11-1
+- Bugzilla Bug #796006 - Get DOGTAG_9_BRANCH GIT repository in-sync
+  with DOGTAG_9_BRANCH SVN repository . . .
+- 'dogtag-pki-ca-theme'
+-      Bugzilla Bug #768138 - Make sure that paging works correctly in CA
+       and DRM
+-      Bugzilla Bug #703608 - Enrollment Profile template Javascript code
+       problem for handling non-dual ECC
+- 'dogtag-pki-common-theme'
+-      Bugzilla Bug #787806 - RSA should be default selection for transport
+       key till "ECC phase 4" is implemented
+-      Bugzilla Bug #784387 - Configuration wizard does not provide option
+       to issue ECC credentials for admin during ECC CA configuration.
+- 'dogtag-pki-console-theme'
+- 'dogtag-pki-kra-theme'
+-      Bugzilla Bug #768138 - Make sure that paging works correctly in CA
+       and DRM
+- 'dogtag-pki-ocsp-theme'
+- 'dogtag-pki-ra-theme'
+- 'dogtag-pki-tks-theme'
+- 'dogtag-pki-tps-theme'
+
+* Thu Jan  5 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.10-1
+- 'dogtag-pki-ca-theme'
+-      Bugzilla Bug #747381 - After the migration (7.1->8.1) CA agent page
+       displays admin cert request with authtime attribute twice
+- 'dogtag-pki-common-theme'
+- 'dogtag-pki-console-theme'
+- 'dogtag-pki-kra-theme'
+- 'dogtag-pki-ocsp-theme'
+- 'dogtag-pki-ra-theme'
+- 'dogtag-pki-tks-theme'
+- 'dogtag-pki-tps-theme'
+
 * Thu Sep 22 2011 Andrew Wnuk <awnuk@redhat.com> 9.0.9-1
 - 'dogtag-pki-ca-theme'
 -      Bugzilla Bug #737423 - Ability to view migrated policy requests
diff --git a/pki/specs/dogtag-pki.spec b/pki/specs/dogtag-pki.spec
index addede4..b5a1c5f 100644
--- a/pki/specs/dogtag-pki.spec
+++ b/pki/specs/dogtag-pki.spec
@@ -1,7 +1,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
 Version:          9.0.0
-Release:          8%{?dist}
+Release:          10%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -11,43 +11,43 @@ BuildArch:        noarch
 
 # Establish MINIMUM package versions based upon platform
 %if 0%{?fedora} >= 17
-%define dogtag_pki_theme_version   9.0.9
+%define dogtag_pki_theme_version   9.0.11
 %define esc_version                1.1.0
 %define jss_version                4.2.6-21
 %define osutil_version             2.0.2
-%define pki_core_version           9.0.16
-%define pki_kra_version            9.0.9
-%define pki_ocsp_version           9.0.8
+%define pki_core_version           9.0.18
+%define pki_kra_version            9.0.10
+%define pki_ocsp_version           9.0.9
 %define pki_ra_version             9.0.4
-%define pki_tks_version            9.0.8
+%define pki_tks_version            9.0.9
 %define pki_tps_version            9.0.7
 %define pki_console_version        9.0.5
 %define tomcatjss_version          6.0.2
 %else
 %if 0%{?fedora} >= 16
-%define dogtag_pki_theme_version   9.0.9
+%define dogtag_pki_theme_version   9.0.11
 %define esc_version                1.1.0
 %define jss_version                4.2.6-19.1
 %define osutil_version             2.0.2
-%define pki_core_version           9.0.15
-%define pki_kra_version            9.0.8
-%define pki_ocsp_version           9.0.7
+%define pki_core_version           9.0.18
+%define pki_kra_version            9.0.10
+%define pki_ocsp_version           9.0.9
 %define pki_ra_version             9.0.4
-%define pki_tks_version            9.0.7
+%define pki_tks_version            9.0.9
 %define pki_tps_version            9.0.7
 %define pki_console_version        9.0.5
 %define tomcatjss_version          6.0.2
 %else
 %if 0%{?fedora} >= 15
-%define dogtag_pki_theme_version   9.0.0
+%define dogtag_pki_theme_version   9.0.11
 %define esc_version                1.1.0
 %define jss_version                4.2.6-17
 %define osutil_version             2.0.1
-%define pki_core_version           9.0.0
-%define pki_kra_version            9.0.0
-%define pki_ocsp_version           9.0.0
+%define pki_core_version           9.0.18
+%define pki_kra_version            9.0.10
+%define pki_ocsp_version           9.0.9
 %define pki_ra_version             9.0.0
-%define pki_tks_version            9.0.0
+%define pki_tks_version            9.0.9
 %define pki_tps_version            9.0.0
 %define pki_console_version        9.0.0
 %define tomcatjss_version          6.0.0
@@ -194,6 +194,16 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Fri Mar  9 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.10-1
+- Bugzilla Bug #796006 - Get DOGTAG_9_BRANCH GIT repository in-sync
+  with DOGTAG_9_BRANCH SVN repository . . .
+
+* Thu Jan  5 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.9-1
+- Bugzilla Bug #737761 - Update Dogtag Packages for Fedora 16
+  (Update minimum packages to account for NSS bug change in
+   Bugzilla Bug #771357 - sslget does not work after FEDORA-2011-17400
+   update, breaking FreeIPA install)
+
 * Fri Oct 28 2011 Matthew Harmsen <mharmsen@redhat.com> 9.0.8-1
 - Bugzilla Bug #749927 - Java class conflicts using Java 7 in Fedora 17
   (rawhide) . . .
diff --git a/pki/specs/pki-core.spec b/pki/specs/pki-core.spec
index 6013163..f6725e5 100644
--- a/pki/specs/pki-core.spec
+++ b/pki/specs/pki-core.spec
@@ -1,6 +1,6 @@
 Name:             pki-core
-Version:          9.0.16
-Release:          4%{?dist}
+Version:          9.0.18
+Release:          1%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -735,18 +735,47 @@ fi
 
 
 %changelog
-* Fri Mar  2 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.16-4
+* Fri Mar  9 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.18-1
+- Bugzilla Bug #796006 - Get DOGTAG_9_BRANCH GIT repository in-sync
+  with DOGTAG_9_BRANCH SVN repository . . .
+- 'pki-setup'
+- 'pki-symkey'
+- 'pki-native-tools'
+- 'pki-util'
+-      Bugzilla Bug #784387 - Configuration wizard does not provide option
+       to issue ECC credentials for admin during ECC CA configuration.
+- 'pki-java-tools'
+- 'pki-common'
+-      Bugzilla Bug #768138 - Make sure that paging works correctly in CA
+       and DRM
+-      Bugzilla Bug #771768 - "Agent-Authenticated File Signing" alters
+       file digest for "logo_header.gif"
+-      Bugzilla Bug #703608 - Enrollment Profile template Javascript code
+       problem for handling non-dual ECC
+-      Bugzilla Bug #223358 - new profile for ECC key generation
+-      Bugzilla Bug #787806 - RSA should be default selection for transport
+       key till "ECC phase 4" is implemented
+- 'pki-selinux'
+- 'pki-ca'
+-      Bugzilla Bug #703608 - Enrollment Profile template Javascript code
+       problem for handling non-dual ECC
+-      Bugzilla Bug #223358 - new profile for ECC key generation
+-      Bugzilla Bug #787806 - RSA should be default selection for transport
+       key till "ECC phase 4" is implemented
+- 'pki-silent'
+
+* Fri Mar  2 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.17-4
 - For 'mock' purposes, removed platform-specific logic from around
   the 'patch' files so that ALL 'patch' files will be included in
   the SRPM.
 
-* Tue Feb 28 2012 Ade Lee <alee@redhat.com> 9.0.16-3
+* Tue Feb 28 2012 Ade Lee <alee@redhat.com> 9.0.17-3
 - 'pki-selinux'
 -      Added platform-dependent patches for SELinux component
 -      Bugzilla Bug #739708 - Selinux fix for ephemeral ports (F16)
 -      Bugzilla Bug #795966 - pki-selinux policy is kind of a mess (F17)
 
-* Wed Feb 22 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.16-2
+* Wed Feb 22 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.17-2
 - Add '-DSYSTEMD_LIB_INSTALL_DIR' override flag to 'cmake' to address changes
   in fundamental path structure in Fedora 17
 - 'pki-setup'
@@ -756,6 +785,29 @@ fi
 - 'pki-selinux'
 -      Bugzilla Bug #795966 - pki-selinux policy is kind of a mess
 
+* Thu Jan  5 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.17-1
+- 'pki-setup'
+- 'pki-symkey'
+- 'pki-native-tools'
+-      Bugzilla Bug #771357 - sslget does not work after FEDORA-2011-17400
+       update, breaking FreeIPA install
+- 'pki-util'
+- 'pki-java-tools'
+-      Bugzilla Bug #757848 - DRM re-key tool: introduces a blank line in the
+       middle of an ldif entry.
+- 'pki-common'
+-      Bugzilla Bug #747019 - Migrated policy requests from 7.1->8.1 displays
+       issuedcerts and cert_Info params as base 64 blobs.
+-      Bugzilla Bug #756133 - Some DRM components are not referring properly
+       to DRM's request and key records.
+-      Bugzilla Bug #758505 - DRM's request list breaks after migration of
+       request records with big IDs.
+-      Bugzilla Bug #768138 - Make sure that paging works correctly in CA and
+       DRM
+- 'pki-selinux'
+- 'pki-ca'
+- 'pki-silent'
+
 * Fri Oct 28 2011 Matthew Harmsen <mharmsen@redhat.com> 9.0.16-1
 - 'pki-setup'
 - 'pki-symkey'
diff --git a/pki/specs/pki-kra.spec b/pki/specs/pki-kra.spec
index be1e654..bd14308 100644
--- a/pki/specs/pki-kra.spec
+++ b/pki/specs/pki-kra.spec
@@ -1,6 +1,6 @@
 Name:             pki-kra
-Version:          9.0.9
-Release:          2%{?dist}
+Version:          9.0.10
+Release:          1%{?dist}
 Summary:          Certificate System - Data Recovery Manager
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -22,8 +22,8 @@ BuildRequires:    nss-devel
 %if 0%{?fedora} >= 16
 BuildRequires:    jpackage-utils >= 0:1.7.5-10
 BuildRequires:    jss >= 4.2.6-19.1
-BuildRequires:    pki-common >= 9.0.15
-BuildRequires:    pki-util >= 9.0.15
+BuildRequires:    pki-common >= 9.0.18
+BuildRequires:    pki-util >= 9.0.18
 BuildRequires:    systemd-units
 %else
 BuildRequires:    jpackage-utils
@@ -35,8 +35,8 @@ BuildRequires:    pki-util
 Requires:         java >= 1:1.6.0
 Requires:         pki-kra-theme >= 9.0.0
 %if 0%{?fedora} >= 16
-Requires:         pki-common >= 9.0.15
-Requires:         pki-selinux >= 9.0.15
+Requires:         pki-common >= 9.0.18
+Requires:         pki-selinux >= 9.0.18
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
 Requires(postun): systemd-units
@@ -238,6 +238,12 @@ fi
 
 
 %changelog
+* Fri Mar  9 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.10-1
+- Bugzilla Bug #796006 - Get DOGTAG_9_BRANCH GIT repository in-sync
+  with DOGTAG_9_BRANCH SVN repository . . .
+- Bugzilla Bug #787806 - RSA should be default selection for transport
+  key till "ECC phase 4" is implemented
+
 * Wed Feb 22 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.9-2
 - Add '-DSYSTEMD_LIB_INSTALL_DIR' override flag to 'cmake' to address changes
   in fundamental path structure in Fedora 17
diff --git a/pki/specs/pki-ocsp.spec b/pki/specs/pki-ocsp.spec
index 3025c1a..a3a3442 100644
--- a/pki/specs/pki-ocsp.spec
+++ b/pki/specs/pki-ocsp.spec
@@ -1,6 +1,6 @@
 Name:             pki-ocsp
-Version:          9.0.8
-Release:          2%{?dist}
+Version:          9.0.9
+Release:          1%{?dist}
 Summary:          Certificate System - Online Certificate Status Protocol Manager
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -248,6 +248,12 @@ fi
 
 
 %changelog
+* Fri Mar  9 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.9-1
+- Bugzilla Bug #796006 - Get DOGTAG_9_BRANCH GIT repository in-sync
+  with DOGTAG_9_BRANCH SVN repository . . .
+- Bugzilla Bug #787806 - RSA should be default selection for transport
+  key till "ECC phase 4" is implemented
+
 * Wed Feb 22 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.8-2
 - Add '-DSYSTEMD_LIB_INSTALL_DIR' override flag to 'cmake' to address changes
   in fundamental path structure in Fedora 17
diff --git a/pki/specs/pki-tks.spec b/pki/specs/pki-tks.spec
index 52751d7..c0db45d 100644
--- a/pki/specs/pki-tks.spec
+++ b/pki/specs/pki-tks.spec
@@ -1,6 +1,6 @@
 Name:             pki-tks
-Version:          9.0.8
-Release:          2%{?dist}
+Version:          9.0.9
+Release:          1%{?dist}
 Summary:          Certificate System - Token Key Service
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -238,6 +238,12 @@ fi
 
 
 %changelog
+* Fri Mar  9 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.9-1
+- Bugzilla Bug #796006 - Get DOGTAG_9_BRANCH GIT repository in-sync
+  with DOGTAG_9_BRANCH SVN repository . . .
+- Bugzilla Bug #787806 - RSA should be default selection for transport
+  key till "ECC phase 4" is implemented
+
 * Wed Feb 22 2012 Matthew Harmsen <mharmsen@redhat.com> 9.0.8-2
 - Add '-DSYSTEMD_LIB_INSTALL_DIR' override flag to 'cmake' to address changes
   in fundamental path structure in Fedora 17
-- 
1.7.7.6