>From f4aa77afe56e2c585687f9bc6297980c8ebcff51 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Wed, 22 Aug 2012 17:26:19 -0400
Subject: [PATCH 52/52] spec file changes for selinux patch

---
 CMakeLists.txt                                |  2 +-
 patches/pki-core-selinux-Dogtag-9-f17-2.patch | 25 ++++++-------------------
 scripts/compose_pki_core_packages             |  2 +-
 specs/pki-core.spec                           |  9 ++++++---
 4 files changed, 14 insertions(+), 24 deletions(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index ad201cbd7b40e5e4ed56fe60fa66b23a571312d8..eb1083fed9f61ec766a354e69c4855936491afb9 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -23,7 +23,7 @@ elseif (BUILD_REDHAT_PKI_THEME)
 elseif (BUILD_PKI_CORE)
     set(APPLICATION_FLAVOR_PKI_CORE TRUE)
     # override APPLICATION VERSION
-    set(APPLICATION_VERSION_PATCH "21")
+    set(APPLICATION_VERSION_PATCH "22")
 elseif (BUILD_PKI_KRA)
     set(APPLICATION_FLAVOR_PKI_KRA TRUE)
     # override APPLICATION VERSION
diff --git a/patches/pki-core-selinux-Dogtag-9-f17-2.patch b/patches/pki-core-selinux-Dogtag-9-f17-2.patch
index 1e222cedc17497f52fb5bfecdb3f5580aecb4dd8..ef8c32733340d0f0dd43b3deda1b45a619c2149c 100644
--- a/patches/pki-core-selinux-Dogtag-9-f17-2.patch
+++ b/patches/pki-core-selinux-Dogtag-9-f17-2.patch
@@ -1,17 +1,7 @@
-From acca26e34d31e5f898465f0725f750ad53201f93 Mon Sep 17 00:00:00 2001
-From: Ade Lee <alee@redhat.com>
-Date: Wed, 22 Aug 2012 08:53:39 -0400
-Subject: [PATCH] Patch for f17 selinux policy
-
----
- base/selinux/src/pki.if | 21 +++++++++++++++++++++
- base/selinux/src/pki.te |  2 +-
- 2 files changed, 22 insertions(+), 1 deletion(-)
-
 diff --git a/base/selinux/src/pki.if b/base/selinux/src/pki.if
-index 0709176ea2e4ad3eea12430a9a653fd9bfef7e3a..7c20ef0bc5bda7612262949b540b93e535bbe169 100644
---- a/base/selinux/src/pki.if
-+++ b/base/selinux/src/pki.if
+index 0709176..7c20ef0 100644
+--- a/pki/base/selinux/src/pki.if
++++ b/pki/base/selinux/src/pki.if
 @@ -38,12 +38,18 @@ template(`pki_ca_template',`
          gen_require(`
                  type java_exec_t;
@@ -54,15 +44,12 @@ index 0709176ea2e4ad3eea12430a9a653fd9bfef7e3a..7c20ef0bc5bda7612262949b540b93e5
  
  ########################################
 diff --git a/base/selinux/src/pki.te b/base/selinux/src/pki.te
-index 089859c8532c9d7d274d65ddd749a17ad630a63b..99ec98eb08c468c02e880d393423b47e49b04cc6 100644
---- a/base/selinux/src/pki.te
-+++ b/base/selinux/src/pki.te
+index 089859c..99ec98e 100644
+--- a/pki/base/selinux/src/pki.te
++++ b/pki/base/selinux/src/pki.te
 @@ -1,4 +1,4 @@
 -policy_module(pki,9.0.2)
 +policy_module(pki,9.0.5)
  
  attribute pki_ca_config;
  attribute pki_ca_executable;
--- 
-1.7.11.2
-
diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index 36b52962a5882be211a4b33404cad7a0687ea540..a5f6dbd4ca2653b7aa060090c262f562dd21a0a3 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CORE="pki-core"
-PKI_CORE_VERSION="9.0.21"
+PKI_CORE_VERSION="9.0.22"
 
 
 ##
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index 049c584ed35bbe23f7bc8b248e427f683ab27be2..be0f58710a1afbd029fdce09a2e7327a1e5170dd 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -1,6 +1,6 @@
 Name:             pki-core
-Version:          9.0.20
-Release:          2%{?dist}
+Version:          9.0.22
+Release:          1%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -749,10 +749,13 @@ fi
 
 
 %changelog
-* Wed Aug 22 2012 Ade Lee <alee@redhat.com> 9.0.20-2
+* Wed Aug 22 2012 Ade Lee <alee@redhat.com> 9.0.22-1
 - Reverted selinux changes that broke f16 selinux policy.
 - Reapplied those changes as a modified patch to f17 build.
 
+* Fri Jul 20 2012 Ade Lee <alee@redhat.com> 9.0.21-1
+- Bugzilla Bug #841996 - latest selinux policy fix breaks dogtag
+
 * Mon May 7 2012 Andrew Wnuk <awnuk@redhat.com> 9.0.20-1
 - New official build
 
-- 
1.7.11.2